%define		pname mod_dosevasive
%define		pversion 1.9
%define 	bversion 1
%define		rpmrelease iworx
%define		apachever 2

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#


%define 	build_mdk_72   0
%define 	build_mdk_80   0
%define 	build_mdk_81   0
%define 	build_mdk_82   0
%define 	build_mdk_90   0
%define		build_mdk_91   0
%define		build_mdk_92   0
%define 	build_rht_7x   0
%define 	build_rht_80   0
%define 	build_rht_90   0
%define 	build_sus_7x   0
%define 	build_sus_80   0
%define 	build_trustix  0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_mdk72:   	%{expand: %%define build_mdk_72   1}}
%{?_with_mdk80:   	%{expand: %%define build_mdk_80   1}}
%{?_with_mdk81:   	%{expand: %%define build_mdk_81   1}}
%{?_with_mdk82:   	%{expand: %%define build_mdk_82   1}}
%{?_with_mdk90:   	%{expand: %%define build_mdk_90   1}}
%{?_with_mdk91:   	%{expand: %%define build_mdk_91   1}}
%{?_with_mdk92:   	%{expand: %%define build_mdk_92   1}}
%{?_with_rht7x:   	%{expand: %%define build_rht_7x   1}}
%{?_with_rht80:   	%{expand: %%define build_rht_80   1}}
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_sus7x:   	%{expand: %%define build_sus_7x   1}}
%{?_with_sus80:   	%{expand: %%define build_sus_80   1}}
%{?_with_trustix: 	%{expand: %%define build_trustix  1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_mdk_92}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 9.2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_91}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 9.1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_90}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 9.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_82}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 8.2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_81}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 8.1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_80}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 8.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_72}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 7.2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rht_7x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 7.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rht_80}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 8.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rht_90}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 9
BuildRequires:	httpd 
BuildRequires:	httpd-devel
Requires:	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_sus_7x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Suse Linux 7.x Series
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_sus_80}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Suse Linux 8.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_trustix}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Linux Trustix
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype CentOS 3.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 1
BuildRequires:	apr 
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 2
BuildRequires:	apr 
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype White Box 3.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	mod_dosevasive -- DOS evasive maneuvers module for Apache
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}.%{version}.tar.gz
URL:		http://www.nuclearelephant.com/projects/dosevasive/

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source1:	mod_dosevasive.conf

%description
mod_dosevasive is an evasive maneuvers module for Apache to provide 
evasive action in the event of an HTTP DoS or DDoS attack or brute 
force attack. It is also designed to be a detection and network 
management tool, and can be easily configured to talk to ipchains, 
firewalls, routers, and etcetera. mod_dosevasive presently reports 
abuses via email and syslog facilities. 

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%setup -q -n %{name}

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

%build

%{_sbindir}/apxs -c mod_dosevasive20.c

%install

## make the "install" dir
mkdir -p %{buildroot}%{_libdir}/httpd/modules
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d

cp -f .libs/mod_dosevasive20.so \
	%{buildroot}%{_libdir}/httpd/modules
cp -f %{SOURCE1} \
	%{buildroot}%{_sysconfdir}/httpd/conf.d/dosevasive.conf

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%pre

%postun

[ -d %{_localstatedir}/%{name} ] && 
	rm -rf %{_localstatedir}/%{name} || :

%post

%files
%defattr(-,root,root)

%attr(0755,root,root) %{_libdir}/httpd/modules/mod_dosevasive20.so
%attr(0640,root,root) %{_sysconfdir}/httpd/conf.d/dosevasive.conf

%changelog
* Sun Aug 29 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS

